package javax.swing.text.rtf;

import java.io.Writer;
import java.io.Reader;
import java.io.OutputStream;
import javax.swing.text.BadLocationException;
import java.io.IOException;
import javax.swing.text.StyledDocument;
import javax.swing.text.Document;
import java.io.InputStream;
import javax.swing.text.StyledEditorKit;

public class RTFEditorKit extends StyledEditorKit
{
    public RTFEditorKit() {
    }
    
    @Override
    public String getContentType() {
        return "text/rtf";
    }
    
    @Override
    public void read(InputStream in, Document doc, int pos) throws IOException, BadLocationException {
        if ((doc instanceof StyledDocument)) {
            RTFReader rtfReader = new RTFReader((StyledDocument)doc);
            rtfReader.readFromStream(in);
            rtfReader.close();
        }
        else {
            super.read(in, doc, pos);
        }
    }
    
    @Override
    public void write(OutputStream outputStream, Document document, int n, int n2) throws IOException, BadLocationException {
        RTFGenerator.writeDocument(document, outputStream);
    }
    
    @Override
    public void read(Reader in, Document doc, int pos) throws IOException, BadLocationException {
        if ((doc instanceof StyledDocument)) {
            RTFReader rtfReader = new RTFReader((StyledDocument)doc);
            rtfReader.readFromReader(in);
            rtfReader.close();
        }
        else {
            super.read(in, doc, pos);
        }
    }
    
    @Override
    public void write(Writer writer, Document document, int n, int n2) throws IOException, BadLocationException {
        throw new IOException("RTF is an 8-bit format");
    }
}
